local media = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("PvPGrid")


function PvPGrid:OnOptionCreate()
	self.options = {
		type = 'group',
		name = GetAddOnMetadata("PvPGrid", "Title"),
		get = function(info)
			return self.db.profile[info[#info]]
		end,
		args = {
			general = {
				type = "group",
				name = L["General"],
				order = 1,
				args = {
					lock = {
						type = "toggle",
						name = L["Lock position"],
						order = 1,
						get = function() 
							return PvPGrid.db.profile.lock 
						end,
						set = function(info, value) 
							PvPGrid.db.profile.lock = value
							if value then
								self.mainframe:EnableMouse(false)
							else
								self.mainframe:EnableMouse(true)
							end
						end,
					},
					gerneal2 = {
						type = "group",
						order = 2,
						inline = true,
						name = L["Baroptions"],
						args = {
							frameheight = {
								type = "range",
								name = L["height"],
								order = 2,
								max = 80,
								min = 6,
								step = 1,
								set = function(info, value)
									self.db.profile.frameheight = value
									width = self.db.profile.framewidth
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename]:SetPoint("TOPLEFT", 0, -10-(i-1)*value)
										self.mainframe[framename]:SetSize(width , value)
										self.mainframe[framename].health:SetSize(width , value)
										self.mainframe[framename].roleicon:SetPoint("TOPLEFT", -value*2-2, 0)
										self.mainframe[framename].roleicon:SetSize(value , value)
										self.mainframe[framename].specicon:SetPoint("TOPLEFT", -value-1, 0)
										self.mainframe[framename].specicon:SetSize(value , value)
										-- medallionscds
										self.mainframe[framename].insi:SetSize(value , value)
										self.mainframe[framename].insi.Icon:SetSize(value , value)
										self.mainframe[framename].insi:SetPoint("TOPRIGHT", value+1, 0)
										self.mainframe[framename].insi.Icon:SetPoint("TOPRIGHT", value+1, 0)
										
										self.mainframe[framename].insi2:SetSize(value , value)
										self.mainframe[framename].insi2.Icon:SetSize(value , value)
										self.mainframe[framename].insi2:SetPoint("TOPRIGHT", 2*value+2, 0)
										self.mainframe[framename].insi2.Icon:SetPoint("TOPRIGHT", 2*value+2, 0)
									end
									self.mainframe['allianceflag']:SetSize(value , value)
									self.mainframe['hordeflag']:SetSize(value, value)
									self.mainframe['netherflag']:SetSize(value, value)
									self.mainframe['blueorb']:SetSize(value , value)
									self.mainframe['purpleorb']:SetSize(value , value)
									self.mainframe['orangeorb']:SetSize(value , value)
									self.mainframe['greenorb']:SetSize(value , value)
								end,
							},
							framewidth = {
								type = "range",
								name = L["width"],
								order = 1,
								max = 500,
								min = 30,
								step = 1,
								set = function(info, value)
									self.db.profile.framewidth = value
									height = self.db.profile.frameheight
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename]:SetSize(value , height)
										self.mainframe[framename].health:SetSize(value , height)
									end
								end,
							},
							fontsize  = {
								type = "range",
								name = L["FontSize"],
								order = 3,
								max = 50,
								min = 5,
								step = 1,
								set = function(info, value)
									self.db.profile.fontsize = value
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename].fontpercent:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
										self.mainframe[framename].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
										self.mainframe[framename].fonttargetcount:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
										self.mainframe[framename].insi.time.font:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
										self.mainframe[framename].insi2.time.font:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									end
									self.mainframe['allianceflag'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['hordeflag'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['netherflag'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['blueorb'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['purpleorb'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['orangeorb'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
									self.mainframe['greenorb'].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , value, "OUTLINE")
								end,
							},
							mainfont = {
								type = "select",
								name = L["Font"],
								order = 4,
								values = media:List("font"),
								itemControl = "DDI-Font",
								get = function()
									for i, v in next, media:List("font") do
										if v == self.db.profile.mainfont then return i end
									end
								end,
								set = function(info, value)
									local list = media:List("font")
									local font = list[value]
									self.db.profile.mainfont = font
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename].fontpercent:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
										self.mainframe[framename].fontname:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
										self.mainframe[framename].fonttargetcount:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
										self.mainframe[framename].insi.time.font:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
										self.mainframe[framename].insi2.time.font:SetFont(media:Fetch("font", font) , self.db.profile.fontsize, "OUTLINE")
									end
								end,
							},
							statusbarframe = {
								type = "select",
								name =  L["Bar texture"],
								order = 5,
								dialogControl = 'LSM30_Statusbar',
								values = AceGUIWidgetLSMlists.statusbar,
								get = function() return self.db.profile.statusbarframe end,
								set = function(win, key)
									self.db.profile.statusbarframe = key
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										self.mainframe[framename].health:SetStatusBarTexture(media:Fetch("statusbar", key))
									end
								end,
							},
							servername = {
								type = "toggle",
								name = L["show servername"],
								order = 6,
								get = function() 
									return PvPGrid.db.profile.servername 
								end,
								set = function(info, value) 
									PvPGrid.db.profile.servername = value
									
									for i=1, 15, 1 do
										local framename = 'enemyplayer'..i
										if PvPGrid.playergrid[i] then
											if PvPGrid.db.profile.servername then
												PvPGrid.mainframe[framename].fontname:SetText(PvPGrid.playergrid[i].name)
											else
												local playername, servername = strsplit("-", PvPGrid.playergrid[i].name)
												PvPGrid.mainframe[framename].fontname:SetText(playername)
											end
										end
									end
								end,
							},
						},
					},
				}
			}
		},
	}



	self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("PvPGrid", PvPGrid.options)
	
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PvPGrid", "PvPGrid", nil, "general")
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PvPGrid", "Profiles", "PvPGrid", "profiles")

end


function PvPGrid:SetupOptions()
	self:RegisterChatCommand("pvpgrid", "ChatCommand")
end

function PvPGrid:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory('PvPGrid')
		InterfaceOptionsFrame_OpenToCategory('PvPGrid')
	else
		--LibStub("AceConfigCmd-3.0").HandleCommand(PvPGrid, "pvpgrid", "PvPGrid", input)
	end
end
